// Fast Fourier analysis of a complex waveform
// SCILAB source file: ex3003.sce
// Set parameters
sample_rate=500; // Set sample rate
t = 0:1/sample_rate:1;
N=size(t,'*'); // Specify number of samples
// Specify a waveform with components at 20 Hz and 60 Hz
s= 0.8*sin(2*%pi*20*t) + 0.2*sin(2*%pi*60*t - %pi/4);
// Plot the function in the time domain
set("current_figure",0); // Time domain in graphic window 0
clf();
plot2d(t,s,3);
title('Time domain (voltage plotted against time)');
// Obtain the Fourier transform  
y=fft(s);
// As the fft response is symmetric we need only the first N/2 points
f=sample_rate*(0:(N/2))/N; //associated frequency vector
n=size(f,'*');
// Clear the graphic display and plot in the frequency domain
set("current_figure",1); // Frequency domain in graphic window 1
clf();
ya = y * 2/N;  // y-axis scale is (amplitude * N/2)
plot2d(f,abs(ya(1:n)),5);
title('Frequency domain (amplitude plotted against frequency)');

